/***************************************************************************
                          drawwidget.cpp  -  description
                             -------------------
    begin                : Fri Dec 10 2004
    copyright            : (C) 2004-2005 by Philip McLeod
    email                : pmcleod@cs.otago.ac.nz
 
   This program is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2 of the License, or
   (at your option) any later version.
   
   Please read LICENSE.txt for details.
 ***************************************************************************/
 
//#include <qmutex.h>
//#include <qthread.h>
//Added by qt3to4:
//#include <Q3PointArray>
//#include <utility>
//#include <algorithm>
//#include <qpixmap.h>

#include "drawwidget.h"
#include "gdata.h"
//#include "useful.h"
//#include "myqmutex.h"
//#include "conversions.h"
//#include "myqt.h"

int DrawWidget::lineWidth = 3;
int DrawWidget::lineTopHalfWidth = 2;
int DrawWidget::lineBottomHalfWidth = 1;

DrawWidget::DrawWidget(QWidget *parent, const char* /*name*/, Qt::WFlags f)
: QWidget(parent, NULL/*name*/, f)
{
  paintDevice = this;
  setLineWidth(3);
  // With double buffering, we don't want QT to clear the display all the time
  setAttribute(Qt::WA_OpaquePaintEvent);

}

void DrawWidget::beginDrawing()
{
  p.begin(paintDevice);
  clearBackground();
}

void DrawWidget::endDrawing()
{
  p.end();
}

void DrawWidget::clearBackground()
{
  p.fillRect(0, 0, width(), height(), gdata->backgroundColor());
}

void DrawWidget::fillBackground(const QColor &color)
{
  p.fillRect(0, 0, width(), height(), color);
}

void DrawWidget::setLineWidth(int width)
{
  lineWidth = width;
  lineTopHalfWidth = lineWidth/2 + (lineWidth % 2);
  lineBottomHalfWidth = lineWidth/2;
}
